package com.sun.org.apache.xalan.internal.xsltc.compiler;

import com.sun.org.apache.xalan.internal.xsltc.compiler.util.ErrorMsg;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.MethodGenerator;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.ClassGenerator;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.TypeCheckError;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.Type;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.Util;

final class Otherwise extends Instruction
{
    Otherwise() {
    }
    
    @Override
    public void display(int indent) {
        this.indent(indent);
        Util.println("Otherwise");
        this.indent(indent + 4);
        this.displayContents(indent + 4);
    }
    
    @Override
    public Type typeCheck(SymbolTable stable) throws TypeCheckError {
        this.typeCheckContents(stable);
        return Type.Void;
    }
    
    @Override
    public void translate(ClassGenerator classGen, MethodGenerator methodGen) {
        Parser parser = this.getParser();
        ErrorMsg err = new ErrorMsg("STRAY_OTHERWISE_ERR", this);
        parser.reportError(3, err);
    }
}
